unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, activex, directshow9, Grids, ValEdit , IniFiles;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ValueListEditor1: TValueListEditor;
    Button1: TButton;
    Button2: TButton;
    procedure CreateGraph;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ValueListEditor1DblClick(Sender: TObject);
    procedure LoadIniFiles;
    procedure SaveIniFiles;
    procedure Panel1Resize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  //
  FGraphBuilder: IGraphBuilder = Nil;
  FMediaControl: IMediaControl = Nil;
  FVideoWindow: IVideoWindow   = Nil;
  //
  Url, Name_ch:string;
  // 
  IniFile: TIniFile;

implementation

{$R *.dfm}

//  
procedure TForm1.CreateGraph;
begin
//  
 if Assigned(FMediaControl) then FMediaControl:= NIL;
 if Assigned(FVideoWindow)  then FVideoWindow := NIL;
 if Assigned(FGraphBuilder) then FGraphBuilder:= NIL;

//    
 if Url='' then exit;

 //  IGraphBuilder
 CoCreateInstance(CLSID_FilterGraph, nil, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, FGraphBuilder);

 // RenderFile -    
 if failed(FGraphBuilder.RenderFile(StringToOleStr(AnsiString(Url)), nil)) then
       begin
         showmessage(' .');
         exit;
       end;

 //  ImediaControl
 FGraphBuilder.QueryInterface(IID_IMediaControl, FMediaControl);

 //  IVideoWindow
 FGraphBuilder.QueryInterface(IID_IVideoWindow, FVideoWindow);

 //    Panel1
 FVideoWindow.put_Owner(Panel1.Handle);
 FVideoWindow.put_WindowStyle(WS_CHILD or WS_CLIPSIBLINGS);
 FVideoWindow.put_MessageDrain(Panel1.Handle);
 FVideoWindow.SetWindowPosition(0, 0, Panel1.ClientRect.Right,Panel1.ClientRect.Bottom);

 //  
 FMediaControl.Run;
end;

//   ValueListEditor1
procedure TForm1.Button1Click(Sender: TObject);
var Url1, Name1: string;
begin
 Url1:= inputbox('  ?',': mms://live.rfn.ru/vesti_24','');
 if Url1<>'' then begin
      Name1:=InputBox('  ?', ':  24','');
      if Name1<>'' then  ValueListEditor1.InsertRow(Name1,Url1,true);
 end;
end;

//   ValueListEditor1
procedure TForm1.Button2Click(Sender: TObject);
begin
if ValueListEditor1.RowCount<=2 then exit;
ValueListEditor1.deleterow(ValueListEditor1.Row);
end;

//// COM
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CoUninitialize;
  //  
  SaveIniFiles;
  IniFile.Free;
end;

// COM
procedure TForm1.FormCreate(Sender: TObject);
begin
  CoInitialize(nil);
  //  
  LoadIniFiles;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if ValueListEditor1.RowCount<>0 then
      Begin
        url:=ValueListEditor1.Cells[1,1];
        Name_ch:=ValueListEditor1.Cells[0,1];
        form1.Caption:=Name_ch;
      End;
end;

//   ValueListEditor1
procedure TForm1.ValueListEditor1DblClick(Sender: TObject);
begin
   url:=ValueListEditor1.Cells[1,ValueListEditor1.Row];
   Name_ch:=ValueListEditor1.Cells[0,ValueListEditor1.Row];
   form1.Caption:=Name_ch;
   //   
   CreateGraph;
end;

procedure TForm1.LoadIniFiles;
var i: integer;
    Url1, Name1: string;
begin

// inifile    Config.ini
IniFile:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'config.ini');
//   inifile
// 

for i:= 1 to IniFile.ReadInteger('RowCount','Count',0) - 1 do
  begin
  Name1:=IniFile.ReadString('Channel','Name'+inttostr(i),'');
  Url1:=IniFile.ReadString('Channel','Url'+inttostr(i),'');
  ValueListEditor1.InsertRow(Name1,Url1,true);
  end;
end;


//        
procedure TForm1.Panel1Resize(Sender: TObject);
begin
if Assigned(FVideoWindow)  then
FVideoWindow.SetWindowPosition(0,0,Panel1.ClientRect.Right,Panel1.ClientRect.Bottom);
end;

procedure TForm1.SaveIniFiles;
var i: integer;
begin
//   inifile
// 
IniFile.WriteInteger('RowCount','Count',ValueListEditor1.RowCount);
//  PlayList
IniFile.EraseSection('Channel');
for i:=1 to ValueListEditor1.RowCount - 1 do
  begin
    IniFile.WriteString('Channel','Name'+inttostr(i),ValueListEditor1.Cells[0,i]);
    IniFile.WriteString('Channel','Url'+inttostr(i),ValueListEditor1.Cells[1,i]);

  end;

end;




end.
